.TH lpim 1 "20 Apr 2002"
.SH NAME
LP_INFO \- Informationen zum Druckkonto anzeigen
.SH SYNOPSIS
.B LP_INFO
[
.B -s
.I DD.MM.JJJJ
] [
.B -e
.I DD.MM.JJJJ
]
.SH OPTIONEN
.TP
.B -s
bestimmt den ersten Tag der Statistik. Ohne Angabe ist der Tag vor PERIOD Tagen.
.TP
.B -e
bestimmt den letzten Tag der Statistik. Ohne Angabe ist es der aktuelle Tag.
.SH BESCHREIBUNG
Das Programm LP_INFO liefert Ihnen den aktuelle Informationen zu Ihrem Druckkonto.
Sie knnen es von der Unix Kommandozeile aufrufen.
.TP
.B Ausgabe
Im
.B Kopf
steht Ihr Benutzername sowie der Zeitraum der Statistik. Falls Sie berchtig sind,
frei zu drucken, wird dies auch angezeigt.
.br
Im
.B Mittelteil
befindet sich die Anzahl der gedruckten Seiten sowie die Zahl der Freidrucke.
Im Zweifelsfalle knnen Sie die Seitenanzahl mit Ihrer eigen Rechnung vergleichen.
.br
Der
.B Fu
der Ausgabe zeigt Ihnen den aktuellen Kontostand an. Auch wenn das Wort Schulden angezeigt wird,
sehen Sie das Minuszeichen vor der Kontostanszahl.
.TP
.B Automatische Information
Im Normall sollten Sie alle PERIOD Tage die Ausgabe des Programms als
eMail erhalten. Sie erhalten die eMail jedoch nur, wenn Sie innerhalb dieses Zeitraums
etwas gedruckt haben oder Geld eingezahlt haben.
.SH BEISPIELE
.TP
.B die letzten PERIOD Tage
druckinfo
.TP
.B seit dem Jahr 2000
LP_INFO -s 1.1.2000
.TP
.B das Sommersemester 2002
LP_INFO -s 1.1.2002 -e 31.9.2002
.SH AUTHOR
Daniel Schmidt <dschm@physik.tu-berlin.de>
