#!/usr/bin/perl

use Gtk;
use Gtk::Atoms;

require "lp_inc";
#Druckerverwaltung
#(C) 2002 by dschm
# Version 25.11.2002

init Gtk;
readconf();
#der Benutzer, welcher das Skript ausfhrt
$cuser=getpwuid($>);

#Fenster oeffnen---
$window = new Gtk::Window('toplevel');
$window -> set_title("Druckerverwaltung");
$main = new Gtk::VBox(0,0);
$main -> border_width(2);
$main -> show;
#---
#notebook
$notebook = new Gtk::Notebook;
$notebook -> border_width(2);
$notebook -> set_tab_pos("top");
$notebook -> show;
#----

#register machen
@frame = ("Konto des Benutzers", "Druckerauftragschlange", "Allgemeine Information","Druckkontingente","Langfristige Festlegung von Freidrucken und Sperrungen");
@label = ("Konto", "Schlange", "Allgemein","Kontingent","Frei/Sperren");
$cnt = 0;
foreach $x (@frame) {
	$f[$cnt] = new Gtk::Frame($frame[$cnt]);
	$f[$cnt] -> border_width(2);
	$f[$cnt] -> show;
	$l[$cnt] = new Gtk::Label($label[$cnt]);
	$l[$cnt] -> set_usize(80,0);
	$l[$cnt] -> show;

	$notebook -> append_page($f[$cnt], $l[$cnt]);
	$cnt++;
}
make_border();
inhalt_konto();
inhalt_schlange();
inhalt_statistik();
inhalt_freeprints();
inhalt_fixed();


$notebook -> set_page(1);
$main -> pack_start($notebook, 1, 1, 1);
$main -> pack_start($sep1, 0, 0, 1);
$main -> pack_start($leiste, 0, 0, 1);


$window -> add($main);
$window -> show;
$FILE_WIN=0;
main Gtk;
exit( 0 );
#----
sub inhalt_konto {
	$vbox0 = new Gtk::VBox(0,0);
	$vbox0 -> border_width(2);
	$f[0] -> add($vbox0);

	$hbox0_1 = new Gtk::HBox(0,0);
	$hbox0_1 -> border_width(2);

	$l0 = new Gtk::Label("Benutzername:");
	$l0 -> set_usize(100,0);

	$entry0 = new Gtk::Entry;
	$entry0 -> set_usize(70,0);

	$ibutton = new Gtk::Button("Anzeigen");
	$ibutton -> set_usize(100,0);
	$ibutton -> border_width(2);
	signal_connect $ibutton "clicked", \&get_userinfo;

	$ibuttonl = new Gtk::Button("Suchen");
	$ibuttonl -> set_usize(100,0);
	$ibuttonl -> border_width(2);
	signal_connect $ibuttonl "clicked", \&list_user;

	$hbox0_1 -> pack_start($l0, 1, 0, 1);
	$hbox0_1 -> pack_start($entry0, 1, 0, 1);
	$hbox0_1 -> pack_start($ibutton, 1, 0, 1);
	$hbox0_1 -> pack_start($ibuttonl, 1, 0, 1);

	$clist0 = new Gtk::CList(1);
	$clist0 -> show;
	$clist0 -> border_width(2);
	$clist0 -> set_column_width(0, 80);
	$clist0 -> set_selection_mode("single");
	$clist0 -> set_usize(100,400);

	$hbox0_2 = new Gtk::HBox(0,0);
	$hbox0_2 -> border_width(2);
	$l1 = new Gtk::Label("Summe $currency: ");
	$l1 -> set_usize(100,0);
	$entry1 = new Gtk::Entry;
	$entry1 -> set_usize(70,0);

	$ibutton_pay = new Gtk::Button("Einzahlen");
	$ibutton_pay -> set_usize(100,0);
	$ibutton_pay -> border_width(2);
	signal_connect $ibutton_pay "clicked", \&pay;

	$ibutton_repay = new Gtk::Button("Zurckzahlen");
	$ibutton_repay -> set_usize(100,0);
	$ibutton_repay -> border_width(2);
	signal_connect $ibutton_repay "clicked", \&repay;

	$hbox0_2 -> pack_start($l1, 1, 0, 1);
	$hbox0_2 -> pack_start($entry1, 1, 0, 1);
	$hbox0_2 -> pack_start($ibutton_pay, 1, 0, 1);
	$hbox0_2 -> pack_start($ibutton_repay, 1, 0, 1);

	$hbox0_3 = new Gtk::HBox(0,0);
	$hbox0_3 -> border_width(2);
	$l2 = new Gtk::Label("Seiten:");
	$l2 -> set_usize(100,0);
	$entryc = new Gtk::Combo();
	$entryc -> set_usize(70,0);
	$entryc->set_popdown_strings( "1","2","3","4","5","6","7","8","9","10" );

	$ibutton_c = new Gtk::Button("gutschreiben");
	$ibutton_c -> set_usize(100,0);
	$ibutton_c -> border_width(2);
	signal_connect $ibutton_c "clicked", \&correct;
	$l_c2 = new Gtk::Label("");
	$l_c2 -> set_usize(100,0);

	$ibutton_b = new Gtk::Button("belasten");
	$ibutton_b -> set_usize(100,0);
	$ibutton_b -> border_width(2);
	signal_connect $ibutton_b "clicked", \&burden;

	$hbox0_3 -> pack_start($l2, 1, 0, 1);
	$hbox0_3 -> pack_start($entryc, 1, 0, 1);
	$hbox0_3 -> pack_start($ibutton_c, 1, 0, 1);
	$hbox0_3 -> pack_start($ibutton_b, 1, 0, 0);

	$vbox0 -> pack_start($clist0, 1, 1, 1);
	$vbox0 -> pack_start($hbox0_1, 0, 0, 1);
	$vbox0 -> pack_start($hbox0_2, 0, 0, 1);
	$vbox0 -> pack_start($hbox0_3, 0, 0, 1);
	$vbox0 -> show_all;
	get_userinfo();
}
sub inhalt_schlange {
	#Register fuer die Druckschlange
	$vbox1 = new Gtk::VBox(0,0);
	$vbox1 -> border_width(2);
	$f[1] -> add($vbox1);

	#scroll element
	$scrolled_window1 = new Gtk::ScrolledWindow( undef, undef );
	$vbox1->pack_start( $scrolled_window1, $true, $true, 0 );
	$scrolled_window1->set_policy( 'automatic', 'always' );
	$scrolled_window1->show();

	$clist1 = new Gtk::CList(1);
	$clist1 -> border_width(2);
	$clist1 -> set_usize(100,400);
	$clist1 -> set_selection_mode("single");

	$clist1->set_shadow_type( 'out' );
	$scrolled_window1->add( $clist1 );

	get_queue();

	$vbox1_buttons = new Gtk::HBox(0,0);
	$vbox1_buttons -> border_width(2);

	$button1_1 = new Gtk::Button("erneuern");
	signal_connect $button1_1 "clicked", \&get_queue, "show";

	$button1_2 = new Gtk::Button("Auftrag lschen");
	signal_connect $button1_2 "clicked", \&removejob, "edit";

	$vbox1_buttons -> pack_start($button1_1, 1, 1, 1);
	$vbox1_buttons -> pack_start($button1_2, 1, 1, 1);

	$vbox1 -> pack_start($vbox1_buttons, 0, 1, 0);

	$button1_3 = new Gtk::Button("Zurcksetzen");
	signal_connect $button1_3 "clicked", sub {reset_queue(); get_queue()} , "edit";

	$vbox1 -> pack_start($button1_3, 0, 1, 0);
	$vbox1 -> show_all;
}
sub inhalt_statistik {
	$vbox2 = new Gtk::VBox(0,0);
	$vbox2 -> border_width(2);
	$f[2] -> add($vbox2);

	#scroll element
	$scrolled_window2 = new Gtk::ScrolledWindow( undef, undef );
	$vbox2->pack_start( $scrolled_window2, $true, $true, 0 );
	$scrolled_window2->set_policy( 'automatic', 'always' );

	$clist2 = new Gtk::CList(1);
	$clist2 -> border_width(2);
	$clist2 -> set_usize(100,400);
	$clist2 -> set_selection_mode("single");

	$clist2->set_shadow_type( 'out' );
	$scrolled_window2->add( $clist2 );

	$vbox2_buttons = new Gtk::HBox(0,0);
	$vbox2_buttons -> border_width(2);

	$button2_1 = new Gtk::Button("Anzeigen");
	signal_connect $button2_1 "clicked", \&get_info, "show";

	$vbox2_buttons -> pack_start($button2_1, 1, 1, 1);

	$vbox2 -> pack_start($vbox2_buttons, 0, 1, 0);
	$vbox2 -> show_all;
}
sub inhalt_freeprints {
	#create register
	$vbox3 = new Gtk::VBox(0,0);
	$vbox3 -> border_width(2);
	$f[3] -> add($vbox3);
	# Create a table
	$table3 = new Gtk::Table( 2, 2, $false );
	$table3->set_row_spacing( 0, 2 );
	$table3->set_col_spacing( 0, 2 );
	$vbox3->pack_start( $table3, 1, 1, 0 );
	# Create the Text widget
	$text3 = new Gtk::Text( undef, undef );
	$text3->set_editable( 1 );
	$text3 -> set_usize(100,400);
	$table3->attach( $text3, 0, 1, 0, 1,
		[ 'expand', 'shrink', 'fill' ],
		[ 'expand', 'shrink', 'fill' ],
		0, 0 );
	# Add a vertical scrollbar to the GtkText widget
	$vscrollbar3 = new Gtk::VScrollbar( $text3->vadj );
	$table3->attach( $vscrollbar3, 1, 2, 0, 1, 'fill',
  	[ 'expand', 'shrink', 'fill' ], 0, 0 );
	#make colors
	$cmap = Gtk::Gdk::Colormap->get_system();
	$color[0]->{ 'red' } = 0xAAAA; $color[0]->{ 'green' } = 0xAAAA; $color[0]->{ 'blue' } = 0xAAAA;
	$color[1]->{ 'red' } = 0xFFFF; $color[1]->{ 'green' } = 0; $color[1]->{ 'blue' } = 0;
	$color[2]->{ 'red' } = 0; $color[2]->{ 'green' } = 0; $color[2]->{ 'blue' } = 0xFFFF;
	$cmap->color_alloc( $color[0] );
	# Load a fixed font
	my $name = "-misc-fixed-medium-r-normal-*-*-140-*-*-c-*-koi8-r";
	$fixed_font = Gtk::Gdk::Font->load( $name );
	open( FILE, "$accdir/contingent" );
	$part_color=1;
	foreach $line ( <FILE> ) {
		if ($line =~ /\[list\]/) {
			$part_color=2;
			$text3->insert( $fixed_font, undef, undef, $line );
			next;
		}
		if ($line =~ /#/) {
			($txt_show,$txt_cmt)=split(/#/,$line,2);
			$text3->insert( $fixed_font, $color[$part_color], undef, $txt_show );
			$text3->insert( $fixed_font, $color[0], undef, "#$txt_cmt" );
		} else {
			$text3->insert( $fixed_font, $color[$part_color], undef, $line );
		}
	}
	close( FILE );
	$text3->thaw();

	$vbox3_buttons = new Gtk::HBox(0,0);
	$vbox3_buttons -> border_width(2);
	$button3_1 = new Gtk::Button("Speichern");
	signal_connect $button3_1 "clicked", \&save_contingent, "show";

	$vbox3_buttons -> pack_start($button3_1, 1, 1, 1);
	$vbox3 -> pack_start($vbox3_buttons, 0, 1, 0);
	$vbox3 -> show_all;
}
sub inhalt_fixed {
	#create register
	$vbox4 = new Gtk::VBox(0,0);
	$vbox4 -> border_width(2);
	$f[4] -> add($vbox4);

	#scroll element
	$konti_frame_free=new Gtk::Frame( "Freies Drucken" );
	$scrolled_window_free= new Gtk::ScrolledWindow( undef, undef );
	$scrolled_window_free->set_policy( 'automatic', 'always' );

	$clist_free = new Gtk::CList(1);
	$clist_free -> set_usize(100,170);

	$clist_free->set_shadow_type( 'out' );
	$scrolled_window_free->add( $clist_free );
	$konti_frame_free->add($scrolled_window_free);

	#scroll element
	$konti_frame_deny=new Gtk::Frame( "Drucken gesperrt" );
	$scrolled_window_deny= new Gtk::ScrolledWindow( undef, undef );
	$scrolled_window_deny->set_policy( 'automatic', 'always' );
	$scrolled_window_deny->show();

	$clist_deny = new Gtk::CList(1);
	$clist_deny -> set_usize(100,170);

	$clist_deny->set_shadow_type( 'out' );
	$scrolled_window_deny->add( $clist_deny );
	$konti_frame_deny->add($scrolled_window_deny);

	$vbox4->pack_start( $konti_frame_free, $true, $true, 0 );
	$vbox4->pack_start( $konti_frame_deny, $true, $true, 0 );

	$vbox4_buttons = new Gtk::HBox(0,0);
	$vbox4_buttons -> border_width(2);

	$button4_1 = new Gtk::Button("Erneuern");
	signal_connect $button4_1 "clicked", \&get_fixed, "show";

	$vbox4_buttons -> pack_start($button4_1, 1, 1, 1);
	$vbox4 -> pack_start($vbox4_buttons, 0, 1, 0);

	$vbox4 -> show_all;
	get_fixed();
}
sub make_border {
	#Rund um alle Register
	$sep1 = new Gtk::HSeparator();

	$leiste = new Gtk::HBox(0,0);
	$leiste -> border_width(2);

	$leiste_label = new Gtk::Label("Drucker");

	$file_label = new Gtk::Label("");

	$but_cfg = new Gtk::Button("Konfiguration");
	$but_cfg -> set_usize(100,25);
	signal_connect $but_cfg "clicked" , \&edit_config ;

	$man = new Gtk::Button("Info");
	$man -> set_usize(100,25);
	signal_connect $man "clicked" , \&manual;

	$exit = new Gtk::Button("Ende");
	$exit -> set_usize(100,25);
	signal_connect $exit "clicked" , sub { exit; };

	$icombo = new Gtk::Combo();
	$icombo -> set_usize(100,0);
	$icombo->set_popdown_strings( @printerlist );

	$leiste -> pack_start($leiste_label, 0, 0, 1);
	$leiste -> pack_start($icombo, 0, 0, 1);
	$leiste -> pack_start($file_label, 1, 1, 1);
	$leiste -> pack_start($but_cfg, 0, 1, 1);
	$leiste -> pack_start($man, 0, 1, 1);
	$leiste -> pack_start($exit, 0, 1, 1);
	$leiste -> show_all;
}
sub get_userinfo {
	#ruft lp_stat auf
	$notebook -> set_page(0);
	$username = $entry0 -> get_text;
	@hallo = getpwnam $username;
	$bfg_text = "";
	@wert = ();
	$wert[0] =  $hallo[6];
	open H, "lp_stat $username|";
	for ($i=0;$l=<H>;$i++) {
		$l =~ s/\n//;
		$wert[$i]=$l;
	}
	close H;
	$clist0 -> clear;
	$c = 0;
	foreach (@wert) {
		$clist0 -> append($wert[$c] );
		$c++;
	}
}
sub removejob {
	#loeschten einen Druckauftrag
	$row = $clist1 -> selection;
	$line = $clist1 -> get_text( $row , 0);
	$pri=$icombo->entry->get_text();
	if ($line =~ /\:/) {
		($nix,$jobid)=split(/\:/,$line);
		$s=sprintf("lprm -P$pri %d",$jobid);
		system($s);
	}
}
sub get_queue {
	#zeit die Druckauftragschlange an
	$pri=$icombo->entry->get_text();
	$clist1 -> clear;
	$i=0;
	open H, "lpq -P$pri -l|";
	$l = <H>;
	$l =~ s/\n//;
	$clist1 -> append($l);
	while ($l=<H>) {
		$l =~ s/\n//;
		if ($l =~ /\[/) {
			($uname,$rest)=split(/:/,$l);
			($a,$b)=split(/\[/,$rest);
			($c,$jobid)=split(/ /,$b);
			($nix,$nix,$nix,$nix,$nix,$nix,$full) = getpwnam($uname);
			$clist1 -> append("$full ($uname)       Nr:$jobid");
			$i++;
		}
	}
	if ($i==0) {
		$clist1->append("empty queue");
	}
	close H;
}
sub reset_queue {
	$pri=$icombo->entry->get_text();
	$c=$queueresetcmd;
	$c =~ s/\$spool/$pri/g;
	system($c);
}
sub get_info {
	#ruft lp_gain auf
	$clist2 -> clear;
	open H, "lp_gain|";
	while ($l=<H>) {
		$l =~ s/\n//;
		$clist2 -> append($l);
	}
	close H;
}
sub get_fixed {
	readconf();
	$clist_free -> clear;
	$clist_deny -> clear;
	@u=split(/,/,print_list($freeuser,$freegroup));
	foreach $i(@u) {
		($nix,$nix,$nix,$nix,$nix,$nix,$full) = getpwnam($i);
		$clist_free->append("$full ($i)");
	}
	@u=split(/,/,print_list($denyuser,$denygroup));
	foreach $i(@u) {
		($nix,$nix,$nix,$nix,$nix,$nix,$full) = getpwnam($i);
		$clist_deny->append("$full ($i)");
	}
}
sub pay {
	$sum = $entry1 -> get_text;
	$username = $entry0 -> get_text;
	if ($sum<=0) { return;}
	system("lp_pay $username $sum");
	get_userinfo();
}
sub repay {
	$sum = $entry1 -> get_text;
	$username = $entry0 -> get_text;
	if ($sum<=0) { return;}
	system("lp_repay $username $sum");
	get_userinfo();
}
sub correct {
	$username = $entry0 -> get_text;
	$corr=$entryc->entry-> get_text;
	$pri=$icombo->entry->get_text();
	if ($corr<=0) {
		return;
	}
	$s=sprintf("lp_acc %s %d c %s",$username,$corr,$pri);
	printf("%s\n",$s);
	system($s);
	get_userinfo();
}
sub burden {
	$username = $entry0 -> get_text;
	$burd=$entryc->entry-> get_text;
	$pri=$icombo->entry->get_text();
	if ($corr<=0) {
		return;
	}
	$s=sprintf("lp_acc %s %d b %s",$username,$corr,$pri);
	printf("%s\n",$s);
	system($s);
	get_userinfo();
}
sub manual {
	system("xterm -e man lpim");
}

sub list_user {
	#oeffnet ein Fenster, welche alle Benutzer enthaelt,
	#die mit $entry0 -> get_text beginnen
	#das Klicken einer Zeile aktualisiert clist0
	$username = $entry0 -> get_text;
	if ($FILE_WIN>0) {
		destroy $file_win; $FILE_WIN = 0;
	}
	if (length($username)<1) {
		return 0;
	}
	$FILE_WIN = 1;
	$spaltenzahl=2; #@spalten=("Benutzername","Vollstndiger Name");

	#create new window
	$file_win = new Gtk::Window('toplevel');
	$file_win -> set_title("Benutzerlist beginnend mit \"$username\"");
	$file_win_vbox = new Gtk::VBox(0,0);
	$file_win_vbox -> border_width(2);
	$file_win -> set_usize(350,350);

	$scrolled_list= new Gtk::ScrolledWindow( undef, undef );
	$scrolled_list->set_policy( 'automatic', 'always' );

	$file_win_list = new Gtk::CList($spaltenzahl);
	$file_win_list -> column_titles_hide;
	$scrolled_list->add( $file_win_list );

	for ($a=0; $a<$spaltenzahl; $a++) {
		$file_win_list -> set_column_width($a, (250 / $spaltenzahl)); #/--syntax-hilfe fuer Editor
		$file_win_list -> set_column_title($a, $a+1);
	}
	$zeilenzahl = 0;
	@userl = ();
	$i=0;
	while ($e=getpwent()) {
		if ($e =~ /^$username/) {
			$userl[$i]=$e;
			$i++;
		}
	}
	endpwent();
	foreach $e(@userl) {
		@feld = ();
		@text = ();
		($feld[0],$nix,$nix,$nix,$nix,$nix,$feld[1]) = getpwnam($e);
		for ($i=0; $i<$spaltenzahl; $i++) {
			chomp $feld[$i];
			push @text, $feld[$i];
		}
		$file_win_list -> append(@text);
	}

	signal_connect $file_win_list "select_row", sub {
		$row = $file_win_list -> selection;
		$username = $file_win_list -> get_text( $row , $userspalte);
		$entry0 -> set_text($username);
		get_userinfo;
		destroy $file_win; $FILE_WIN = 0;
	};

	$file_win_hbox = new Gtk::HBox(0,0);
	$file_win_hbox -> border_width(2);

	$file_win_label1 = new Gtk::Label("");

	$file_win_button1 = new Gtk::Button("schlieen");
	$file_win_button1 -> set_usize(80,0);
	signal_connect $file_win_button1 "clicked", sub { destroy $file_win; $FILE_WIN = 0; };

	$file_win_hbox -> pack_start($file_win_label1, 1, 1, 1);
	$file_win_hbox -> pack_start($file_win_button1, 0, 0, 1);

	$file_win_vbox -> pack_start($scrolled_list, 1, 1, 1);
	$file_win_vbox -> pack_start($file_win_hbox, 0, 0, 1);

	$file_win -> add($file_win_vbox);
	$file_win -> show_all;
}
sub save_contingent {
	open H,">$accdir/contingent";
	print H $text3->get_chars( 0, -1 );
	close H;
}
sub save_config {
	open H,">$configfile";
	print H $textcfg->get_chars( 0, -1 );
	close H;
}

sub edit_config {
	if ($FILE_WIN>0) {
		destroy $file_win; $FILE_WIN = 0;
	}
	$FILE_WIN = 1;
	#create new window
	$file_win = new Gtk::Window('toplevel');
	$file_win -> set_title("Konfiguration");
	$vboxcfg = new Gtk::VBox(0,0);
	$vboxcfg -> border_width(2);
	# Create a table
	$tablecfg = new Gtk::Table( 2, 2, $false );
	$tablecfg->set_row_spacing( 0, 2 );
	$tablecfg->set_col_spacing( 0, 2 );
	$vboxcfg->pack_start( $tablecfg, 1, 1, 0 );
	# Create the Text widget
	$textcfg = new Gtk::Text( undef, undef );
	$textcfg->set_editable( 1 );
	$textcfg -> set_usize(400,400);
	$tablecfg->attach( $textcfg, 0, 1, 0, 1,
		[ 'expand', 'shrink', 'fill' ],
		[ 'expand', 'shrink', 'fill' ],
		0, 0 );
	# Add a vertical scrollbar to the GtkText widget
	$vscrollbarcfg = new Gtk::VScrollbar( $textcfg->vadj );
	$tablecfg->attach( $vscrollbarcfg, 1, 2, 0, 1, 'fill',
  	[ 'expand', 'shrink', 'fill' ], 0, 0 );
	#make colors
	$cmap = Gtk::Gdk::Colormap->get_system();
	$color[0]->{ 'red' } = 0xAAAA; $color[0]->{ 'green' } = 0xAAAA; $color[0]->{ 'blue' } = 0xAAAA;
	$color[1]->{ 'red' } = 0xFFFF; $color[1]->{ 'green' } = 0; $color[1]->{ 'blue' } = 0;
	$color[2]->{ 'red' } = 0; $color[2]->{ 'green' } = 0; $color[2]->{ 'blue' } = 0xFFFF;
	$color[3]->{ 'red' } = 0; $color[3]->{ 'green' } = 0xBBBB; $color[3]->{ 'blue' } = 0;
	$cmap->color_alloc( $color[0] );
	# Load a fixed font
	my $name = "-misc-fixed-medium-r-normal-*-*-140-*-*-c-*-koi8-r";
	$fixed_font = Gtk::Gdk::Font->load( $name );
	open( FILE, $configfile );
	foreach $line ( <FILE> ) {
		if ($line =~ /^\[/) {
			$textcfg->insert( $fixed_font, $color[3], undef, $line );
			next;
		}
		if ($line =~ /#/) {
			($txt_1,$txt_cmt)=split(/#/,$line,2);
			$txt_cmt="#$txt_cmt";
		} else {
			$txt_1=$line;
			$txt_cmt="";
		}
		if ($txt_1 =~ / /) {
			($txt_par,$txt_val)=split(/ /,$txt_1,2);
			$txt_val=" $txt_val";
		} else {
			$txt_par=$txt_1;
			$txt_val="";
		}
		$textcfg->insert( $fixed_font, $color[2], undef, $txt_par );
		$textcfg->insert( $fixed_font, $color[1], undef, $txt_val);
		$textcfg->insert( $fixed_font, $color[0], undef, $txt_cmt);
	}
	close( FILE );
	$textcfg->thaw();

	$vboxcfg_buttons = new Gtk::HBox(0,0);
	$vboxcfg_buttons -> border_width(2);
	$buttoncfg_1 = new Gtk::Button("Speichern");
	signal_connect $buttoncfg_1 "clicked", sub{ save_config(); readconf(); make_border();}, "show";
	$buttoncfg_2 = new Gtk::Button("Abbrechen");
	signal_connect $buttoncfg_2 "clicked", sub { destroy $file_win; $FILE_WIN = 0;}, "show";


	$vboxcfg_buttons -> pack_start($buttoncfg_1, 1, 1, 1);
	$vboxcfg_buttons -> pack_start($buttoncfg_2, 1, 1, 1);
	$vboxcfg -> pack_start($vboxcfg_buttons, 0, 1, 0);
	$file_win -> add($vboxcfg);
	$file_win -> show_all;
}
