#! /usr/bin/perl
#this script replace all 'regexpr' in 'file' against 'replacement'
#dont use special characters
#many exceptions, be careful!
sub usage {
	print "usage $0 [regexpr] [replacement] -- [file(s)]\n"
}
if ($#ARGV<3) {
	usage;
	exit 1;
}
$file=$ARGV[3];
$regexpr=$ARGV[0];
$replacement=$ARGV[1];
$tmp="/tmp/strrepl.tmp";
if ($ARGV[2] !~ /\-\-/) {
	usage;
	exit 1;
}
for ($i=3;$i<=$#ARGV;$i++) {
	$file=$ARGV[$i];
	if (! -e $file ) {
		print "cannot open file $file\n";
		exit 1;
	}

	open HAND, "$file";
	open NEW, ">$tmp";
	while ($u=<HAND>) {
		$u =~ s/$regexpr/$replacement/g;
		printf NEW "%s",$u;
	}
	close NEW;
	close HAND;
	system "cat $tmp >$file";
	#system "mv $tmp $file";
	unlink "$tmp";
}
