#! /usr/bin/perl
#
# lpim - List Printer Account Improved
#
require "lp_inc";

#output for usage of program
sub usage {
	print "usage $0 user value\n";
        print "user\tusername\n";
	print "value\tvalue of currency user has payed\n";
	print "\tformat: x.xx, must be valid positive value\n";
}
readconf();
#---
# check for username parameters
$user=$ARGV[0];
$money=$ARGV[1];
if ($#ARGV<1) {
	usage();
	exit;
}
#---
# does user exist ?
($uname,$nix)=getpwnam($user);
if (!$user) {
	printf("No such user '$user'\n");
	usage;
	exit;
}
#---
if ( $money < 0)  {
	usage;
	exit;
}
#---
#does file exists?
touch_user_file($user);
#---
#parse current time
($s,$m,$h,$d,$mn,$y,$wd,$yd,$i)=gmtime(time);
$mn++; #special format of unix time struct
$y+=1900; #special format of unix time struct
$dat= sprintf ("%04s%02s%02s%02s%02s%02s", $y, $mn, $d, $h, $m, $s);
#---
$s = sprintf ("%s:%s:%d:%s:%s:%.2f\n", $dat, $user, $pages,"+","",$money);
open HAND, ">>$accdir/$user.acc";
print HAND $s;
close HAND;
